/* Andrei Parvu
   O(N^2)
*/

#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

#define lg 200005

int timp;
int parinte[lg];
int been[lg];
bool fst[lg];

vector<int> v[lg];
int dontgo1, dontgo2;

vector<pair<int, int> > muchii;

void df(int nod) {
  fst[nod] = true;

  for (int i = 0; i < (int)v[nod].size(); i++) {
    if (fst[v[nod][i]] == false) {
      parinte[v[nod][i]] = nod;
      df(v[nod][i]);
    }
  }
}

pair<int, int> doit(int nod) {
  been[nod] = timp;

  int x1 = 0, x2 = 0;

  int mx1 = 0, mx2 = 0;

  for (int i = 0; i < (int)v[nod].size(); i++) {
    if (been[v[nod][i]] != timp && v[nod][i] != dontgo1 &&
        v[nod][i] != dontgo2) {
      pair<int, int> ret = doit(v[nod][i]);

      x1 = max(x1, ret.first);
      x2 = max(x2, ret.second + 1);

      if (ret.second + 1 >= mx1) {
        mx2 = mx1;
        mx1 = ret.second + 1;
      } else if (ret.second + 1 >= mx2) {
        mx2 = ret.second + 1;
      }
    }
  }

  return make_pair(max(x1, mx1 + mx2), x2);
}

int main() {
  freopen("plimbare.in", "rt", stdin);
  freopen("plimbare.out", "wt", stdout);

  int n, x, y;

  scanf("%d", &n);

  for (int i = 1; i < n; i++) {
    scanf("%d %d", &x, &y);

    v[x].push_back(y);
    v[y].push_back(x);

    muchii.push_back(make_pair(x, y));
  }

  df(1);

  for (int i = 0; i < (int)muchii.size(); i++) {
    int nod;

    if (parinte[muchii[i].first] == muchii[i].second) {
      nod = muchii[i].first;
    } else {
      nod = muchii[i].second;
    }

    timp++;

    dontgo1 = nod;
    dontgo2 = parinte[nod];

    pair<int, int> x = doit(nod);
    pair<int, int> y = doit(parinte[nod]);

    printf("%d\n", x.first + y.first + 1);
  }

  return 0;
}

