#include <cstdio>
#include <algorithm>
#include <fstream>
#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <cstring>
#include <string>
#include <set>

#define pb push_back
#define mp make_pair
#define f first
#define s second
#define ll long long

const int MAXN = 100005;

using namespace std;

ll A[MAXN], sum[MAXN];
int N;


void my_insert(int poz, ll val) {
  
  for (int i = N + 1; i > poz + 1; --i)
    A[i] = A[i - 1];

  A[poz + 1] = val ;
  
  ++N; 
  
  for (int i = 1 ; i <= N; ++i)
    sum[i] = sum[i - 1] + A[i];
}
void my_erase(int poz) {

  for (int i = poz ; i <= N; ++i)
    A[i] = A[i + 1]; 
  --N;

  for (int i = 1; i <= N; ++i)
    sum[i] = sum[i - 1] + A[i];

}  
int query() {
  
  if (sum[N] < 0)
    return -1;
  
  ll ans = 0 , pz = 0;
  for (int i = 1; i <= N; ++i)
    if (ans > sum[i]) {
      ans = sum[i];
      pz = i;
    }
  
  return pz;
}
int main() {
  
  ifstream cin("rotatii.in");
  ofstream cout("rotatii.out");

  int M;

  cin >> N >> M;
  
  for (int i = 1; i <= N; ++i)
    cin >> A[i];

  for (int i = 1; i <= N; ++i)
    sum[i] = sum[i - 1] + A[i];
/*
  for (int i = 1; i <= N ; ++i)
    cerr << A[i] << " " ;
  cerr << "\n";
*/
  for (; M--; ) {
    int op ;
    int where; ll value;
/*
    cerr << "before\n";
    for (int i = 1; i <= 2 * N; ++i)
      cerr << A[i] << " ";
    cerr << "\n";
*/
    cin >> op;
    if (op == 0) {
      cin >> where >> value ;
      my_insert(where, value);
    } else if (op == 1) {
      cin >> where; 
      my_erase(where) ;
    } else if (op == 2) {
      cout << query() << "\n";
    }
/*
    cerr << "after\n";

    for (int i = 1; i <= 2 * N; ++i)
      cerr << A[i] << " " ;
    cerr << "\n";
*/
  }
  
}
