//Dragos Oprica
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
using namespace std;

const int NMAX=1005;

vector <pair <int,int> > solution;
int T,N,X;

struct cmp {
	bool operator () (const int &a,const int &b) {
		cout<<"0 "<<X<<" "<<a<<" "<<b<<"\n"; cout.flush ();

		int response; cin>>response;
		return response==a;
	}
};

void get_tree (vector <int> nodes) {
	if (nodes.size ()==1)
		return ;
	if (nodes.size ()==2)
		solution.push_back (make_pair (nodes.front (),nodes.back ()));
	else if (nodes.size ()==3) {
        cout<<"0 "<<nodes[0]<<" "<<nodes[1]<<" "<<nodes[2]<<"\n"; cout.flush ();

		int response; cin>>response;
		if (response==nodes[0]) {
			solution.push_back (make_pair (nodes[0],nodes[1]));
			solution.push_back (make_pair (nodes[0],nodes[2])); 
		}
		else if (response==nodes[1]) {
			solution.push_back (make_pair (nodes[0],nodes[1]));
			solution.push_back (make_pair (nodes[1],nodes[2]));	
		}
		else {
			solution.push_back (make_pair (nodes[0],nodes[2]));
			solution.push_back (make_pair (nodes[1],nodes[2])); 
		}
	}
	else {        
		int A,B;
		do {
			A=nodes[rand ()%nodes.size ()];
		    B=nodes[rand ()%nodes.size ()];
		} while (A==B); X=A;
                
 
		vector <int> chain; 
		vector <int> other[NMAX];  
		for (unsigned i=0; i<nodes.size (); ++i)
			if (nodes[i]!=A && nodes[i]!=B) {
				cout<<"0 "<<A<<" "<<B<<" "<<nodes[i]<<"\n"; cout.flush ();

				int response; cin>>response;
				if (response==nodes[i])
					chain.push_back (nodes[i]);
				else
					other[response].push_back (nodes[i]);
			}

		sort (chain.begin (),chain.end (),cmp ()); 
        reverse (chain.begin (),chain.end ()); 
		chain.push_back (A);
        reverse (chain.begin (),chain.end ()); 
		chain.push_back (B); 
        
		for (unsigned i=0; i+1<chain.size (); ++i)
			solution.push_back (make_pair (chain[i],chain[i+1]));

		for (unsigned i=0; i<chain.size (); ++i) {
		    other[chain[i]].push_back (chain[i]);
			get_tree (other[chain[i]]);
		}
	}
}

int main () {
	srand (time (NULL));
	
	cin>>T;
    for (int t=1; t<=T; ++t) {	
		cin>>N;

		vector <int> nodes;
		for (int i=1; i<=N; ++i)
			nodes.push_back (i);

		solution.clear ();
		get_tree (nodes); 
		
		cout<<"1\n"; cout.flush ();
		for (unsigned i=0; i<solution.size (); ++i) {
			cout<<solution[i].first<<" "<<solution[i].second<<"\n";
			cout.flush ();
		}
	}
	
	return 0;
}
