#include<fstream>
#include<iostream>
#include<vector>

#define pb push_back

using namespace std;

vector <int > v[300009];
int sw[300006],lant[300005],diam[300005],father[300005],n,up[300005];
int D[300005];

vector< pair <int, int > > mc;

void citire() {
    ifstream f("plimbare.in");
    int i, j,x,y;
    f>> n;
    for (i=1;i<n;i++) {
        f>> x >> y;
        v[x].pb(y);
        v[y].pb(x);
        mc.pb(make_pair(x,y));
    }
    f.close();
}

void df(int nod ) {
    vector<int> :: iterator it ;
    sw[nod]=1;
    for (it=v[nod].begin();it<v[nod].end();it++)
        if (sw[*it]==0) {
            father[*it]=nod;
            df(*it);
        }
}

void diameter(int nod) {
    vector<int> :: iterator it;
    lant[nod]=0;
    diam[nod]=0;

    int max1=-1, max2=-1;
    for (it=v[nod].begin();it<v[nod].end();it++)
        if (*it!=father[nod]) {
            diameter(*it);
            if (lant[*it] >= max1) {
                max2=max1;
                max1=lant[*it];
            } else if (lant[*it] > max2) {
                max2= lant[*it];
            }
            diam[nod]=max(diam[nod],diam[*it]);
        }

    lant[nod]=max1 + 1 ;
    diam[nod]=max(diam[nod],max1+max2+2);
}

void dfcomputeup(int nod ) {
    vector <int > :: iterator it;
    int mx1=-1,mx2=-1,l1,l2;

    for (it=v[nod].begin();it<v[nod].end();it++)
        if (*it!=father[nod]) {
            if (lant[*it]+1>=mx1) {
                mx2=mx1; mx1=lant[*it]+1;
                l2=l1,l1=*it;
            } else if (lant[*it]+1>mx2) {
                mx2=lant[*it]+1;
                l2=*it;
            }
        }

    for (it=v[nod].begin();it<v[nod].end();it++) {
        if (*it!= father[nod]) {
            up[*it]=up[nod]+1;
            if (*it!=l1) {
                up[*it]=max (up[*it],mx1+1 );
            }
            else
                up[*it]=max (up[*it],mx2+1);
            dfcomputeup(*it);
        }
    }
}

void computed(int nod) {
    vector<int> :: iterator it ;

    int mx1=0,mx2=0,mx3=0,l1,l2,l3,b1=0,b2=0,bl1=0,bl2=0;

    if (nod ==1) D[nod]= 0 ;

    for (it=v[nod].begin();it<v[nod].end();it++)
        if (*it!=father[nod]) {
            if (lant[*it]+1>=mx1) {
                mx3=mx2; mx2=mx1; mx1=lant[*it]+1;
                l3=l2;l2=l1,l1=*it;
            } else if (lant[*it]+1>=mx2) {
                mx3=mx2;mx2=lant[*it]+1;
                l3=l2;l2=*it;
            } else if(lant[*it]+1 > mx3) {
                mx3=lant[*it]+1;
                l3=*it;
            }

            if (diam[*it]>=b1) {
                b2=b1;b1=diam[*it];
                bl2=bl1;bl1=*it;
            } else if (diam[*it]>b2) {
                b2=diam[*it]; bl2=*it;
            }
        }

    for (it=v[nod].begin();it<v[nod].end(); it++ ) {
        if (*it!=father[nod]) {
            int val =0;
            if (l1==*it) {
                val=mx2;
                if (mx3>up[nod])
                    val+=mx3 ;
                else val +=up[nod];
            } else if (l2== *it) {
                    val=mx1;
                    if (mx3>up[nod])
                        val+= mx3; else val += up[nod];
                } else {
                    val= mx1;
                    if (mx2>up[nod]) val+=mx2;
                        else val+=up[nod];
                }
            D[*it]=max(D[nod],val);

            if (bl1==*it)
                D[*it]=max (D[*it],b2);
            else
                D[*it]=max (D[*it],b1);

            computed(*it);
        }
    }
}

void afisare() {
    ofstream f("plimbare.out");

//    for (int i=2;i<=n;i++)
//        f<< D[i]+ diam[i]+1 << '\n';

    for (int i=0;i<mc.size();i++)
        if (mc[i].second==father[mc[i].first])
            f<<D[mc[i].first]+diam[mc[i].first]+1<<'\n';
        else
            f<<D[mc[i].second]+ diam[mc[i].second]+1<<'\n';

    f.close();
}

int main () {
    citire();
    df(1);
    diameter(1);
    up[1]=0;
    dfcomputeup(1);
    computed (1);
    afisare();
    return 0;
}
