#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

int main() {
    ifstream cin("rotatii.in");
    ofstream cout("rotatii.out");

    int N, M; cin >> N >> M;

    vector<int> V(N);
    for (int i = 0; i < N; ++i)
        cin >> V[i];

    for (int i = 0; i < M; ++i) {
        int type; cin >> type;
        if (type == 0) {
            int where, value; cin >> where >> value;
            V.insert(V.begin() + where, value);
        } else if (type == 1) {
            int where; cin >> where;
            V.erase(V.begin() + where - 1);
        } else {
            long long best = 0, sum = 0;
            int where = -1;
            for (int j = 0; j < int(V.size()); ++j) {
                sum += V[j];
                if (sum < best) {
                    best = sum;
                    where = j;
                }
            }

            if (sum < 0)
                cout << "-1\n";
            else
                cout << where + 1 << "\n";
        }
    }
}
